
 ;   sb.asm - secondary bootloader 
 ;
 ;
 ;   Copyright (c) 2003 Lonesome & OSDev Group
 ;
 ;   http://tyros.sourceforge.net/
 ;   http://sourceforge.net/projects/tyros/
 ;
 ;   (c) 2007 Vkos
 ;   http://logoros.narod.ru
 ;
 ;   This program is free software; you can redistribute it and/or modify
 ;   it under the terms of the GNU General Public License as published by
 ;   the Free Software Foundation; either version 2, or (at your option)
 ;   any later version.
 ;
 ;   This program is distributed in the hope that it will be useful,
 ;   but WITHOUT ANY WARRANTY; without even the implied warranty of
 ;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ;   GNU General Public License for more details.
 ;
 ;   You should have received a copy of the GNU General Public License
 ;   along with this program (see the file COPYING); if not, write to the
 ;   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 ;   Boston, MA  02111-1307, USA
 ;
 ;
 ;
	
	
[BITS 16]
[ORG 0x700]

	;;     0   

	cli	
	mov ax, 0
	mov ds, ax
	mov es, ax
	mov ss, ax
	mov sp, 0x700
	sti
		
	;;    
	mov si, msg_intro
	call kputs

	;;   
	mov bp, font
	mov ah, 0x11
	mov al, 0x00
	mov cx, 0xFF
	mov dx, 0x00
	mov bh, 0x10
	mov bl, 0x00
	int 0x10

	;;   ,    PM
	mov si, msg_entering_pmode
	call kputs

	;;  ,    
	mov ah, 1
	mov ch, 0x20
	int 0x10

	;;       0x20
	mov al,00010001b 
	out 0x20,al 
	mov al,0x20 
	out 0x21,al 
	mov al,00000100b 
	out 0x21,al
	mov al,00000001b	
	out 0x21,al 

	
	;;  
	cli
	
	;;   GDTR:	
	lgdt [gd_reg]

	;;  A20: 
	in al, 0x92
	or al, 2
	out 0x92, al

	;;   PE  CR0
	mov eax, cr0 
	or al, 1	
	mov cr0, eax  

	;;      
	;;      CS
	;; (   )
	jmp 0x8: _protected


	;;     
	;;   !
	;; (  0x10 BIOS)
kputs:
	pusha
.loop:
	lodsb
	test al, al
	jz .quit
	mov ah, 0x0e
	int 0x10
	jmp short .loop
.quit:
	popa
	ret


	;;   - 32-
[BITS 32]
	;;    
	;;    PM
_protected:	
	;;   DS  SS 
	;;  
	mov ax, 0x10
	mov ds, ax
	mov es, ax
	mov ss, ax

	;;   (kernel.bin)    2
	;;   

	;; kernel_binary - ,  
	;;  
	;; ( -   )
	mov esi, kernel_binary

	;; ,   
	mov edi, 0x200000


	;;     
	;; (65536 )
	mov ecx, 0x4000

	;;  :)
	rep movsd

	;;  ,   
	jmp 0x200000


gdt:
	dw 0, 0, 0, 0	;  

	db 0xFF		;    DPL=0 
	db 0xFF		; =0  =4  
	db 0x00
	db 0x00
	db 0x00
	db 10011010b
	db 0xCF
	db 0x00
	
	db 0xFF		;    DPL=0
	db 0xFF		; =0  =4	
	db 0x00	
	db 0x00
	db 0x00
	db 10010010b
	db 0xCF
	db 0x00


	;; ,     GDTR:	
gd_reg:
	dw 8192
	dd gdt

msg_intro:	db "Secondary bootloader received control", 0x0A, 0x0D, "Loading russian font... ", 0
msg_entering_pmode:	db "  !   ...", 0x0A, 0x0D, 0

font:	incbin 'koi8-r.fnt'

times 0x200*11-($-$$) db 0

kernel_binary:	
	incbin 'kernel/kernel.bin'